"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OBDOuterSubscriber_1 = require("../model/OBDOuterSubscriber");
function oxygenSensorSTFT(sensor) {
    return function (source) {
        return source.lift(new OxygenSensorSTFTOperator(sensor));
    };
}
exports.oxygenSensorSTFT = oxygenSensorSTFT;
var OxygenSensorSTFTOperator = /** @class */ (function () {
    function OxygenSensorSTFTOperator(sensor) {
        this.sensor = sensor;
    }
    OxygenSensorSTFTOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new OxygenSensorSTFTSubscriber(subscriber, this.sensor));
    };
    return OxygenSensorSTFTOperator;
}());
var OxygenSensorSTFTSubscriber = /** @class */ (function (_super) {
    __extends(OxygenSensorSTFTSubscriber, _super);
    function OxygenSensorSTFTSubscriber(destination, sensor) {
        var _this = _super.call(this, destination) || this;
        _this.sensor = sensor;
        return _this;
    }
    /**
     * Return the frequency of execution of this command.
     * @return that this command must be executed every pulse.
     */
    OxygenSensorSTFTSubscriber.prototype.pulse = function () {
        return 1;
    };
    /**
     * Return the string representation of the OBD Read command.
     * @returns the string representation of the OBD Read command
     */
    OxygenSensorSTFTSubscriber.prototype.command = function () {
        return "01 " + ['14', '15', '16', '17', '18', '19', '1A', '1B'][this.sensor - 1] + " 1\r";
    };
    /**
     * Return the name of the OBD Field on OBD Data object.
     * @returns the name of the OBD Field on OBD Data object.
     */
    OxygenSensorSTFTSubscriber.prototype.field = function () {
        return ["oxygenSensorVoltage" + this.sensor, "oxygenSensorShortTermFuelTrim" + this.sensor];
    };
    /**
     * Parse the OBD response.
     * @param bytes the response read from OBD.
     * @returns the parsed response.
     */
    OxygenSensorSTFTSubscriber.prototype.parse = function (bytes) {
        return [parseInt(bytes[2], 16) / 200, (parseInt(bytes[3], 16) * 1.28) - 100];
    };
    return OxygenSensorSTFTSubscriber;
}(OBDOuterSubscriber_1.OBDOuterSubscriber));
//# sourceMappingURL=oxygenSensorSTFT.js.map